/* RaWi-JS-Plugin:  Dropdown-Tabs (animierte Version)
*  JS-File:         ddtabs.js
*  CSS-File:        ddtabs.css */
(function() {
  // Constructor
  this.Dropdowntabs = function() {
    // Globale Plugin-Element-Referenz
    this.dropdowntabs = null;
    // Vars
    this.tabcontentArray = new Array();
    this.tabcontentheightArray = new Array();
    // Option-Defaults
    var defaults = {
      idTabs:      'ddtabs',           // ID-Dropdown-Tabs
      cHeadClosed: 'tabhead',          // Klasse Tab-Head geschlossen
      cHeadOpen:   'tabhead current',  // Klasse Tab-Head offen
      cTabcontent: 'tabcontent',       // Klasse Tab-Content-Div
      openFlag:    false,              // Flag zum ffnen eines Tabs beim Aufruf der Seite
      openTab:     0,                  // Nummer des zu ffnenden Tabs (0 bis X)
      closeFlag:   true                // Offene Tabs schlieen (true) oder offen lassen (false)
    }
    // bernahme der Option-Defaults bzw. der Argumente der Seite
    if (arguments[0] && typeof arguments[0] === "object") {
      this.options = extendDefaults(defaults, arguments[0]);
    }
    // Dropdowntabs-Div
    this.dropdowntabs = document.getElementById(this.options.idTabs);
    // Array der Tab-Heads
    this.tabHeadArray = this.dropdowntabs.querySelectorAll('[class='+this.options.cHeadClosed+']');
    // EventListener zu den Tab-Heads hinzufgen
    for (var i = 0; i < this.tabHeadArray.length; i++) {
      this.tabHeadArray[i].addEventListener('click', this.handleClick.bind(this,i));
    }
    // Array der Tab-Content-Divs
    this.tabcontentArray = this.dropdowntabs.querySelectorAll('[class='+this.options.cTabcontent+']');
    // Hhe der Tab-Content-Divs ermitteln und dann auf Null stellen
    for (var i = 0; i < this.tabcontentArray.length; i++) {
      var rect = this.tabcontentArray[i].getBoundingClientRect();
      this.tabcontentheightArray[i] = rect.height;
      this.tabcontentArray[i].style.height = '0px';
    }
    // openFlag === true -> entsprechenden Tab ffnen
    if (this.options.openFlag === true) this.openTab(this.options.openTab);
  }
  // ---------------
  // Plugin-Methoden
  // ---------------
  // Tab ffnen
  Dropdowntabs.prototype.openTab = function(tabnumber) {
    this.tabHeadArray[tabnumber].className = this.options.cHeadOpen;
    this.tabcontentArray[tabnumber].style.height = this.tabcontentheightArray[tabnumber] + 'px';
  }
  // Tab schlieen
  Dropdowntabs.prototype.closeTab = function(tabnumber) {
    this.tabHeadArray[tabnumber].className = this.options.cHeadClosed;
    this.tabcontentArray[tabnumber].style.height = '0px';
  }
  // Funktion handleClick
  Dropdowntabs.prototype.handleClick = function(tabnumber,event) {
    // Bereits offene Tabs schlieen wenn closeFlag === true
    if (this.options.closeFlag === true) {
      for (var i = 0; i < this.tabHeadArray.length; i++) {
        // wenn ein anderer Tab offen, dann schlieen
        if (this.tabHeadArray[i].className == this.options.cHeadOpen && tabnumber != i) {
          this.closeTab(i);
        }
      }
    }
    // Angeklickten Tab ffnen/schlieen
    if (this.tabcontentArray[tabnumber].style.height == '0px') {
      // Tab ist geschlossen -> ffnen
      this.openTab(tabnumber);
    } else {
      // Tab ist offen -> schlieen
      this.closeTab(tabnumber);
    }
  }
  // ------------------------------
  // Option defaults implementieren
  // ------------------------------
  function extendDefaults(source, properties) {
    var property;
    for (property in properties) {
      if (properties.hasOwnProperty(property)) {
        source[property] = properties[property];
      }
    }
    return source;
  }
}());